<template>
  <div class="q-px-lg q-pt-lg container">
    <q-table title="Products" :data="products" :columns="columns" row-key="id">
      <template v-slot:body="props">
        <q-tr :props="props">
          <q-td key="name" :props="props" auto-width>
            <div class="ellipsis">{{ props.row.name }}</div>
          </q-td>
          <q-td key="price" :props="props">
            <div class="ellipsis">{{ props.row.price }}</div>
          </q-td>
          <q-td key="description" :props="props">
            <div class="ellipsis">{{ props.row.description }}</div>
          </q-td>

          <q-td>
            <q-btn @click="toggleView(props.row)" color="primary" label="View info"></q-btn>
          </q-td>
        </q-tr>
      </template>
    </q-table>
    <q-btn
      @click="openDialogAdd = true"
      flat
      style="font-size: 4em; width: 100%;"
      class="justify-center"
      color="primary"
      label="+"
    />

    <q-dialog v-model="openDialogEdit">
      <q-card>
        <q-card-section class="q-pb-xs top" align="left">
          <div v-if="!isEditing" class="text-h6">{{ selectedProduct.name }}</div>
          <div v-if="isEditing" class="column">
            <p class="q-mb-sm text-caption">Numele produsului</p>
            <q-input outlined :rules="rules" v-model="selectedProduct.name" dense clearable />
          </div>

          <div>
            <q-btn v-if="isEditing" @click="saveChanges()" flat color="positive" icon="check" />
            <q-btn @click="deleteProduct()" flat color="negative" icon="delete" />
            <q-btn v-if="!isEditing" @click="isEditing = true" flat color="primary" icon="edit" />
          </div>
        </q-card-section>
        <q-separator />
        <q-card-section v-if="!isEditing" class="q-pb-xs">
          <q-img :src="selectedProduct.image" style="width: 100px"></q-img>
        </q-card-section>

        <q-card-section class="q-pb-xs">
          <p v-if="isEditing" class="q-mb-sm text-caption">Adaugati o imagine (max. 100Kb)</p>

          <q-file
            v-if="isEditing"
            style="max-width: 300px"
            v-model="image"
            filled
            rounded
            label="Image"
            accept=".jpg, image/*"
          />
        </q-card-section>
        <q-card-section class="q-pb-xs">
          <p v-if="isEditing" class="q-mb-sm text-caption">Pretul produsului</p>
          <q-input
            v-if="isEditing"
            outlined
            :rules="rules"
            v-model="selectedProduct.price"
            :placeholder="selectedProduct.price"
            dense
            clearable
          />
          <div v-if="!isEditing">
            <span class="text-weight-medium">Pret:</span>
            {{ selectedProduct.price }} RON
          </div>
        </q-card-section>

        <q-card-section class="q-pt-xs">
          <p v-if="isEditing" class="q-mb-sm text-caption">Descrierea produsului</p>

          <q-input
            v-if="isEditing"
            outlined
            :rules="rules"
            v-model="selectedProduct.description"
            :placeholder="selectedProduct.description"
            dense
            clearable
            autogrow
          />
          <div v-if="!isEditing">
            <span class="text-weight-medium">Descriere:</span>
            {{ selectedProduct.description }}
          </div>
        </q-card-section>

        <q-card-section class="q-pt-xs">
          <p class="text-caption">Detaliile produsului</p>

          <q-table
            class="my-sticky-header-table"
            :data="selectedProduct.preferences"
            :columns="columnsPreferences"
            row-key="id"
            :pagination.sync="pagination"
            :rows-per-page-options="[0]"
            flat
            virtual-scroll
          >
            <template v-slot:body="props">
              <q-tr :props="props">
                <q-td key="size" :props="props">
                  {{ props.row.size }}
                  <q-popup-edit
                    v-if="isEditing"
                    v-model="props.row.size"
                    buttons
                    label-set="Save"
                    label-cancel="Close"
                    :validate="existanceValidation"
                    @hide="existanceValidation"
                  >
                    <q-input
                      v-model="props.row.size"
                      :error="errorExistance"
                      :error-message="errorMessageExistance"
                      dense
                      autofocus
                    />
                  </q-popup-edit>
                </q-td>
                <q-td key="color" :props="props">
                  {{ props.row.color }}
                  <q-popup-edit
                    v-if="isEditing"
                    v-model.number="props.row.color"
                    buttons
                    label-set="Save"
                    label-cancel="Close"
                    :validate="existanceValidation"
                    @hide="existanceValidation"
                  >
                    <q-input
                      v-model.number="props.row.color"
                      :error="errorExistance"
                      :error-message="errorMessageExistance"
                      dense
                      autofocus
                    />
                  </q-popup-edit>
                </q-td>
                <q-td key="quantityAvailable" :props="props">
                  {{ props.row.quantityAvailable }}
                  <q-popup-edit
                    v-if="isEditing"
                    v-model.number="props.row.quantityAvailable"
                    buttons
                    label-set="Save"
                    label-cancel="Close"
                    :validate="existanceValidation"
                    @hide="existanceValidation"
                  >
                    <q-input
                      v-model.number="props.row.quantityAvailable"
                      :error="errorExistance"
                      :error-message="errorMessageExistance"
                      dense
                      autofocus
                    />
                  </q-popup-edit>
                </q-td>
                <q-td v-if="isEditing" key="actions" :props="props">
                  <q-btn
                    @click="deleteProductPreference(props.rowIndex)"
                    flat
                    color="negative"
                    icon="delete"
                  />
                </q-td>
              </q-tr>
            </template>
          </q-table>
          <q-btn
            v-if="isEditing"
            @click="isAddNewPreference=true"
            flat
            color="primary"
            label="Adauga o noua preferinta"
          />
          <q-btn v-if="isEditing" @click="goBack" flat color="accent" label="Inapoi" />

          <div v-if="isAddNewPreference" class="row">
            <div class="column">
              <p class="q-mb-sm text-caption">Marime</p>

              <q-input
                outlined
                :rules="rules"
                v-model="newPreference.size"
                placeholder="Alegeti marimea produsului"
                dense
                mask="XXX"
                clearable
              />
            </div>
            <div class="column">
              <p class="q-mb-sm text-caption">Culoare</p>
              <q-input
                outlined
                :rules="rules"
                v-model="newPreference.color"
                placeholder="Alegeti culoarea produsului"
                dense
                clearable
              />
            </div>
            <div class="column">
              <p class="q-mb-sm text-caption">Cantitate disponibila</p>
              <q-input
                outlined
                :rules="rules"
                v-model="newPreference.quantityAvailable"
                placeholder="Alegeti cantitatea disponibila (buc)"
                mask="#####"
                dense
                clearable
              />
            </div>

            <q-btn @click="addProductPreference" flat label="salveaza preferinta" color="primary" />
          </div>
        </q-card-section>
      </q-card>
    </q-dialog>

    <q-dialog v-model="openDialogAdd">
      <q-card>
        <q-card-actions align="right">
          <q-btn @click="saveAddProduct" flat color="positive" icon="check" />
          <q-btn @click="openDialogAdd = false" flat color="negative" icon="clear" />
        </q-card-actions>
        <q-card-section>
          <p class="q-mb-sm text-caption">Numele produsului</p>

          <q-input outlined v-model="newProduct.name" placeholder="Name" :rules="rules" dense />
        </q-card-section>
        <q-card-section class="q-pt-none">
          <p class="q-mb-sm text-caption">Adaugati o imagine (max. 100Kb)</p>

          <q-file style="max-width: 300px" v-model="image" label="Imagine" accept=".jpg, image/*" />
        </q-card-section>
        <q-card-section class="q-pt-xs">
          <p class="q-mb-sm text-caption">Pretul produsului</p>

          <q-input
            outlined
            :rules="rules"
            type="number"
            :min="1"
            v-model="newProduct.price"
            placeholder="Price"
            dense
          />
        </q-card-section>
        <q-card-section class="q-pt-none">
          <p class="q-mb-sm text-caption">Descrierea produsului</p>

          <q-input
            dense
            :rules="rules"
            v-model="newProduct.description"
            placeholder="Description"
            clearable
            outlined
            autogrow
          />
        </q-card-section>

        <p class="q-pl-md">Adaugati detaliile produsului</p>
        <q-card-section>
          <p
            v-if="newProduct.preferences.length<1"
            class="text-primary"
          >Nu exista detalii pentru produs. Trebuie sa adaugati detalii noi.</p>

          <q-table
            v-else
            class="my-sticky-header-table"
            :data="newProduct.preferences"
            :columns="columnsNewPreference"
            row-key="id"
            :pagination.sync="pagination"
            :rows-per-page-options="[0]"
            flat
          ></q-table>
        </q-card-section>

        <q-card-section>
          <p class="q-mb-sm text-caption">Alegeti categoria din care face parte produsul</p>
          <q-select
            filled
            class="q-mb-md"
            v-model="newProduct.categoryId"
            :options="categoriesList"
          />
        </q-card-section>

        <q-card-section class="row">
          <div class="column">
            <p class="q-mb-sm text-caption">Marime</p>
            <q-input
              outlined
              mask="XXX"
              :rules="rules"
              v-model="newPreference.size"
              placeholder="Choose product size"
              dense
              clearable
            />
          </div>

          <div class="column">
            <p class="q-mb-sm text-caption">Culoare</p>
            <q-input
              outlined
              :rules="rules"
              v-model="newPreference.color"
              placeholder="Choose product color"
              dense
              clearable
            />
          </div>

          <div class="column">
            <p class="q-mb-sm text-caption">Cantitate disponibila</p>
            <q-input
              outlined
              mask="####"
              :rules="rules"
              v-model="newPreference.quantityAvailable"
              placeholder="Choose product quantity available"
              dense
              clearable
            />
          </div>

          <q-btn @click="saveProductPreference" flat label="salveaza preferinta" color="primary" />
        </q-card-section>
      </q-card>
    </q-dialog>
  </div>
</template>

<script>
//la add product
//select category, la preferences
import { LocalStorage } from "quasar";

const toBase64 = (file) =>
  new Promise((resolve, reject) => {
    const reader = new FileReader();
    reader.readAsDataURL(file);
    reader.onload = () => resolve(reader.result);
    reader.onerror = (error) => reject(error);
  });

export default {
  name: "products",
  beforeMount() {
    this.$store.dispatch("adminData/loadCategories");
    if (!LocalStorage.getItem("loggedIn")) {
      this.$router.push("/auth");
    } else if (!LocalStorage.getItem("user").isAdmin) this.$router.push("/");
  },
  data() {
    return {
      image: null,
      openDialogAdd: false,
      openDialogEdit: false,
      isEditing: false,
      isAddNewPreference: false,
      errorExistance: false,
      errorMessageExistance: "",
      selectedProduct: {},
      newProduct: {
        id: 0,
        name: "",
        description: "",
        price: 0,
        categoryId: 0,
        preferences: [],
      },
      newPreference: {
        size: "",
        color: "",
        quantityAvailable: 0,
      },

      rules: [(val) => !!val || "Campul nu poate fi gol"],
      pagination: {
        rowsPerPage: 3,
      },
      columnsNewPreference: [
        {
          name: "size",
          label: "Marime",
          field: "size",
          align: "center",
        },
        {
          name: "color",
          label: "Culoare",
          field: "color",
          align: "center",
        },
        {
          name: "quantityAvailable",
          label: "Cantitate disponibila (buc)",
          field: "quantityAvailable",
          align: "center",
        },
      ],
      columns: [
        {
          name: "name",
          label: "Name",
          field: "name",
          align: "center",
          style: "max-width: 30%",
        },
        {
          name: "price",
          label: "Price",
          field: "price",
          align: "center",
          style: "max-width: 30%",
        },
        {
          name: "description",
          label: "Description",
          field: "description",
          style: "max-width: 400px",

          align: "center",
        },
        {
          name: "actions",
          align: "left",
          style: "max-width: 5%",
        },
      ],
      columnsPreferences: [
        {
          name: "size",
          label: "Marime",
          field: "size",
          align: "center",
        },
        {
          name: "color",
          label: "Culoare",
          field: "color",
          align: "center",
        },
        {
          name: "quantityAvailable",
          label: "Cantitate disponibila (buc)",
          field: "quantityAvailable",
          align: "center",
        },
        {
          name: "actions",
          field: "actions",
          align: "center",
          style: "max-width: 50px",
        },
      ],
    };
  },

  methods: {
    goBack() {
      this.isEditing = false;
      this.isAddNewPreference = false;
    },
    toggleView(item) {
      this.openDialogEdit = true;
      this.selectedProduct = JSON.parse(JSON.stringify(item));
    },
    saveChanges() {
      if (this.selectedProduct.preferences.length === 0) {
        this.$q.notify({
          color: "negative",
          message: "Trebuie sa adaugi detalii",
          icon: "report_problem",
        });
      } else if (
        !(
          this.selectedProduct.name &&
          this.selectedProduct.price &&
          this.selectedProduct.description
        )
      ) {
        this.$q.notify({
          color: "negative",
          message:
            "Trebuie sa completezi marimea, culoarea si cantitatea disponibila",
          icon: "report_problem",
        });
      } else if (this.image) {
        toBase64(this.image).then((image) => {
          this.$axios
            .put("/api/products", {
              ...this.selectedProduct,
              image,
            })
            .then((response) => {
              this.$q.notify({
                message: response.data.message,
                color: "positive",
              });
              this.$store.dispatch("adminData/loadProducts");
              this.openDialogEdit = false;
              this.isEditing = false;
              this.image = null;
            })
            .catch((err) => {
              this.$q.notify({
                color: "negative",
                message: err.response.data.message,
                icon: "report_problem",
              });
            });
        });
      } else
        this.$axios
          .put("/api/products", this.selectedProduct)
          .then((response) => {
            this.$q.notify({
              message: response.data.message,
              color: "positive",
            });
            this.$store.dispatch("adminData/loadProducts");
            this.openDialogEdit = false;
            this.isEditing = false;
            this.image = null;
          })
          .catch((err) => {
            this.$q.notify({
              color: "negative",
              message: err.response.data.message,
              icon: "report_problem",
            });
          });
    },
    saveProductPreference() {
      if (!this.newProduct.categoryId.value) {
        this.$q.notify({
          message: "Selectati categoria din care face parte produsul.",
          color: "negative",
        });
      } else if (
        !this.newPreference.quantityAvailable &&
        this.newPreference.color &&
        this.newPreference.size
      ) {
        this.$q.notify({
          message: "Completati marimea, culoarea si cantitatea disponibila.",
          color: "negative",
        });
      } else if (
        this.newProduct.preferences.length < 1 &&
        this.newPreference.quantityAvailable &&
        this.newPreference.color &&
        this.newPreference.size
      ) {
        (this.newPreference.size = this.newPreference.size.toLocaleUpperCase()),
          this.newProduct.preferences.push({ ...this.newPreference });
      } else {
        const foundPreference = this.newProduct.preferences.find(
          (item) =>
            item.size == this.newPreference.size &&
            item.color == this.newPreference.color
        );

        if (foundPreference)
          this.$q.notify({
            message:
              "Nu puteti adauga de doua ori detalii pentru aceeasi marime si culoare",
            color: "negative",
          });
        else if (
          this.newPreference.quantityAvailable &&
          this.newPreference.color &&
          this.newPreference.size
        )
          (this.newPreference.size = this.newPreference.size.toLocaleUpperCase()),
            this.newProduct.preferences.push(this.newPreference);
      }
    },
    deleteProductPreference(index) {
      this.selectedProduct.preferences.splice(index, 1);
    },
    addProductPreference() {
      if (
        this.newPreference.quantityAvailable &&
        this.newPreference.color &&
        this.newPreference.size
      )
        this.selectedProduct.preferences.push({
          color: this.newPreference.color.toLocaleLowerCase(),
          size: this.newPreference.size.toLocaleUpperCase(),
          quantityAvailable: this.newPreference.quantityAvailable,
          id: this.newPreference.size + this.newPreference.color,
        });
      this.isAddNewPreference = false;
    },
    saveAddProduct() {
      if (this.newProduct.preferences.length < 1) {
        this.$q.notify({
          color: "negative",
          message: "Trebuie sa adaugi detalii",
          icon: "report_problem",
        });
      }
      if (
        !(
          this.newProduct.name &&
          this.newProduct.price &&
          this.newProduct.description &&
          this.image
        )
      ) {
        this.$q.notify({
          message:
            "Completeaza campul de nume, descriere, pret si adauga o imagine",
          color: "negative",
        });
      } else {
        toBase64(this.image).then((image) => {
          this.$axios
            .post("/api/products", {
              ...this.newProduct,
              image,
              categoryId: this.newProduct.categoryId.value,
            })
            .then((response) => {
              this.$q.notify({
                message: response.data.message,
                color: "positive",
              });
              this.$store.dispatch("adminData/loadProducts");
              this.openDialogAdd = false;
              this.image = null;
              this.isAddNewPreference = false;
              this.newProduct = {
                id: 0,
                name: "",
                description: "",
                price: 0,
                preferences: [],
              };
            })
            .catch((err) => {
              this.$q.notify({
                color: "negative",
                message: err.response.data.message,
                icon: "report_problem",
              });
            });
        });
      }
    },

    deleteProduct() {
      //dialog de confirmare
      this.$q
        .dialog({
          message: `Are you sure you want to delete ${this.selectedProduct.name}?`,
          color: "red-9",
          cancel: true,
          persistent: true,
        })
        .onOk(() => {
          this.$axios
            .delete("/api/products", { data: { id: this.selectedProduct.id } })
            .then((response) => {
              this.openDialogEdit = false;
              this.$q.notify({
                message: response.data.message,
                color: "positive",
              });
              this.$store.dispatch("adminData/loadProducts");
            })
            .catch((error) => {
              this.$q.notify({
                color: "negative",

                message: error.response.data.message,
                icon: "report_problem",
              });
            });
        })
        .onCancel(() => {});
    },

    existanceValidation(val) {
      if (!val) {
        this.errorExistance = true;
        this.errorMessageExistance = "Campul nu poate fi gol";
        return false;
      }
      this.errorExistance = false;
      this.errorMessageExistance = "";
      return true;
    },
  },
  computed: {
    categories() {
      return this.$store.getters["adminData/getCategories"];
    },
    sizes() {
      return this.$store.getters["adminData/getSizes"];
    },
    colors() {
      return this.$store.getters["adminData/getColors"];
    },
    products() {
      return this.$store.getters["adminData/getProducts"];
    },
    categoriesList() {
      return this.categories.map((item) => ({
        label: item.name,
        value: item.id,
      }));
    },
    //sa nu putem sa adaugam 2 la fel
  },
};
</script>

<style lang="scss" scoped>
.container {
  display: flex;
  flex-direction: column;
  justify-content: center;

  .q-table_container {
    max-width: 700px;
  }
}

.q-card {
  width: 100%;
  max-height: 500px;
  .top {
    display: flex;
    flex-direction: row;
    justify-content: space-between;
  }
}

.q-table {
  td {
    word-wrap: break-word;
  }
}

.my-sticky-header-table {
  /* height or max-height is important */
  min-height: 110px;
  max-height: 310px;

  .q-table__top,
  .q-table__bottom,
  thead tr:first-child th {
    /* bg color is important for th; just specify one */
    background-color: #c1f4cd;
  }

  thead tr th {
    position: sticky;
    z-index: 1;
  }

  thead tr:first-child th {
    top: 0;
  }

  /* this is when the loading indicator appears */
  &.q-table--loading thead tr:last-child th {
    /* height of all previous header rows */
    top: 48px;
  }
}
</style>